

function love.load()

	w=love.graphics.getWidth()
	h=love.graphics.getHeight()
	pi=math.pi
	
	function circle(x,y,r,sx,sy,sides)
		local line=love.graphics.line
		
		if sides==nil then sides=30 end
		if sx==nil then sx=1 end
		if sy==nil then sy=1 end
		
		local s=sides --number of segments
		
		local a1,a2 --angle
		
		local x1,y1,x2,y2
		for i=1,s do
			a1=2*pi*(i-1)/s --angle, starts at 0.
			a2=2*pi*(i)/s
			x1=x+sx*r*math.cos(a1)
			y1=y+sy*r*math.sin(a1)
			x2=x+sx*r*math.cos(a2)
			y2=y+sy*r*math.sin(a2)
			line(x1,y1,x2,y2)
		
			
		end
		
	end

	function position(long,lat,string)
	-- latitude and longitude should be in terms of (n*pi) radians
	-- longitude ranges from -1 to +1
	-- latitude ranges from -0.5 to +0.5
	
		--or just convert to radians always
		long=long/180
		lat=lat/180
		
		
	--  ----------------------
		local rx=loop(rx+lat,-1,1)
		local ry=loop(ry+long,-1,1)

		local x,y,sx,sy
	
		x=w/2
		y=h/2
		--rad=200
		sx=math.sin(ry*pi)
		sy=1

		x=w/2+sx*rad*math.cos(rx*pi)
		y=h/2+sy*rad*math.sin(rx*pi)
			
		if ry>-0.5 and ry<0.5 and string~=nil then love.graphics.print(string,x,y) end
			
		return x,y
		

	end
	
	function loop(o,min,max)
		local range=max-min
		if o<min then o=o+range end
		if o>max then o=o-range end
		return o
	end
	
	function bound(o,min,max)
		if o>min and o<max then return true else return false end
	end
	
	function shading(w,h,rad)
	local lg=love.graphics
	lg.setColor(255,255,255,4)
	local f=0.5
	
---[[
	f=0.1 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.2 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.3 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.4 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.5 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.6 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.7 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.8 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.9 lg.push() lg.scale((f),1) lg.translate(w*(1/f/2-1/2),0) lg.circle('fill',w/2,h/2,rad) lg.pop()
--]]
	
---[[	
	f=0.1	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.2	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.3	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.4	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.5	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.6	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.7	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.8	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
	f=0.9	lg.push() lg.scale(1,(f)) lg.translate(0,h*(1/f/2-1/2)) lg.circle('fill',w/2,h/2,rad) lg.pop()
--]]	
	end
	
	function drawPoint(long,lat) --in degrees
		--lg.setColor(255,255,255)
		--local long,lat=0,0
		local lg=love.graphics
		local x,y=position(long,lat)
		local ry=ry*180+long
		ry=loop(ry,-180,180)
		
		--[[
		if ry>-90 and ry<90 then
			lg.setColor(0,255,0)
			love.graphics.print(long..', '..lat,x,y)
		end	
		--]]
		if ry>-90 and ry<90 and lat>-90 and lat<90 then
			--lg.setColor(255,0,0)
			love.graphics.print(long..', '..lat,x,y)
		end	
		
		if ry<-90 or ry>90 then
			if lat<-90 or lat>90 then
				--lg.setColor(0,0,255)
				love.graphics.print(long..', '..lat,x,y)
			end
		end

end
	
	--rotation of globe
	rx=0 ry=0	
	
	--radius
	rad=200
	
	--
	px,py=0,0
	
end

function love.keypressed(key)
	if key=='return' then rx=0 ry=0 px=0 py=0 end--love.graphics.setBackgroundColor(0,0,0) end
	if key=='end' then love.graphics.setBackgroundColor(0,0,0) end
end

function love.update(dt)

	--auto rotation
	--ry=ry+dt/6

	--user input
	local lkd=love.keyboard.isDown
	local s=dt/5
	
	if lkd('pageup') then ry=ry-s end
	if lkd('pagedown') then ry=ry+s end

	rx=loop(rx,-1,1) --pi
	ry=loop(ry,-1,1) --pi
	
	----
	local s=dt*90
	if lkd('left') then px=px-s end
	if lkd('right') then px=px+s end
	if lkd('up') then py=py-s end
	if lkd('down') then py=py+s end
	px=loop(px,-180,180)
	--py=loop(py,-90,90)
	py=loop(py,-180,180)

	--rotation based on px
	--problem when ry goes from 180 to -180.
	--
	
	local s=math.abs(px+ry*180)
	if  s>180 then 
		love.graphics.setBackgroundColor(255,20,100)
		s=dt*(px-ry*180)/90
	else
		s=dt*(px+ry*180)/90--shouldn't exceed 1
	end

	--default
	--s=dt*(px+ry*180)/90--shouldn't exceed 1
	
	local m=1
	s=math.max(math.min(s,m),-m)
	ry=ry-s
end

function love.draw()
	local lg=love.graphics
	lg.setColor(255,255,255)
	lg.print(px+ry*180,0,0)

	------ new notes
	lg.setColor(250,250,250)
	
	--lg.print("the globe is now drawn in such a way that it can be manipulated in love.graphics.push/pop\nThe next big issue has to do with the 'flashing' error in how the longitude lines are drawn.\nAlso look at the odd way in which the line size is changed",10,30)
	--lg.printf("this new method of drawing the globe isn't yet fixed enough so that I can rotate about the horizontal axis, but at least I can now manipulate the image within the push() pop() functions\n\nNext would be to finish the ability to draw continents on the globes surface.",10,10,300,'left')
	lg.printf('right now the rotation of the globe is based on the player position and the rotation of the globe. A problem happens when either number switches from positive to negative, i.e. from 180 to -180 or the reverse.\n\nKEYS\n\ return resets position to 0,0\n arrow keys move point on globe\n page up and page down rotates globe\n end resets  background color',10,30,600)
	lg.printf('TWO BIG THINGS TO WORK ON\n 1) point moving around the globe\n 2) drawing continents on the globe surface ',10,430,600)
	------
	
	lg.setColor(255,255,255)
	--lg.print('rx: '..rx,10,10) --doesn't change
	lg.print('ry: '..ry*180,w/2,10)
	
	---------
	lg.push() 
	--lg.scale(2,2)
	--lg.translate(-50,-100)
	--lg.rotate(0.02*pi)
	
	lg.setColor(100,100,155)
	lg.circle('fill',w/2,h/2,rad)

	--circle(w/2,h/2,rad)
	
	shading(w,h,rad)
	
	--line colors
	love.graphics.setColor(255,255,255,100)

	local x1,y1,x2,y2
	

	--longitude

	local s=5

	for long=-180,180-15,15 do
		local rx=(rx*180)+long
		local ry=loop(ry+long/180,-1,1)
		
		local lineWidth=1
		
		if math.cos(ry*pi)>0.1 then

			lineWidth=2*math.abs(math.cos(ry*pi))
			lg.setLineWidth(lineWidth)
			
			for i=-90,90,s do
			
				x1,y1=position(rx,i)
				x2,y2=position(rx,math.min(90,i+s))
				
				if bound(ry,-0.5,0.5) and bound(i,-90,90) then
					love.graphics.line(x1,y1,x2,y2) 
				end
				
			end
		end
			
		lg.setLineWidth(1)
	end
	
	--draw latitude lines
	for lat=-90,90,15 do

		lg.setLineWidth(2*math.abs(math.cos(lat*pi/180)))
	
		local min,max=0,30
		min,max=-180,180
		for long=min,max,s do
			local rx1=(rx*180)+long
			local rx2=math.min(max,rx1+s)
			local ry=loop(ry+long/180,-1,1)

		
			--lg.print(math.floor(ry*10)/10,0,300+long*2)
			
			x1,y1=position(rx1,lat)
			x2,y2=position(rx2,lat)

			if ry>1/2 or ry<-1/2 then 
				--don't draw
			else 
				love.graphics.line(x1,y1,x2,y2)
			end
			
		end
	end
	
	lg.setLineWidth(1)
	lg.setColor(255,255,255)
	circle(w/2,h/2,rad)
		
	---[[
	--test polygon nation
	love.graphics.setColor(0,0,0,130)
	local a,b,c,d,e,f,g,h1,i,j,k,l
	a,b=position(0,0)
	c,d=position(10,25)
	e,f=position(15,30)
	g,h1=position(100,18)
	i,j=position(1,5)
	k,l=position(5,6)
	love.graphics.polygon('fill',a,b,c,d,e,f,g,h1,i,j,k,l)
	
	lg.setColor(200,0,0,100)
	a,b=position(-40,-20)
	c,d=position(-30,-15)
	e,f=position(-30,-45)
	g,h1=position(-60,-50)
	love.graphics.polygon('fill',a,b,c,d,e,f,g,h1)

	lg.setColor(0,200,0,100)
	a,b=position(40,-20)
	c,d=position(30,-15)
	e,f=position(30,-45)
	g,h1=position(60,-50)
	love.graphics.polygon('fill',a,b,c,d,e,f,g,h1)
	

	--]]

	--test putting shading in a new location.  Will the effect look good over the continents?
	--shading(w,h,rad)
	
	--[[
	--make into a new function: draw point
	lg.setColor(255,255,255)
	local long,lat=0,0
	local x,y=position(long,lat)
	local ry=ry*180
	if ry>-90 and ry<90 then
		lg.print(long..', '..lat,x,y)
	end
	--]]
	
	--[[
		lg.setColor(255,255,255)
		drawPoint(0,0)
		drawPoint(10,10)
		lg.setColor(255,0,255)
		drawPoint(100,100)
		lg.setColor(255,255,0)
		drawPoint(100,-100)
		lg.setColor(0,255,0)
	--]]
		lg.setColor(255,255,255)
		drawPoint(px,py)
	
	lg.pop()
	lg.setColor(0,0,0)
	lg.rectangle('line',w/2-5,h-60,80,20)
	lg.print('press  END',w/2,h-60)
end